<?php

namespace Ulmus\Attribute\Property;

use Ulmus\Attribute\Attribute;
use Ulmus\Query;

#[\Attribute(\Attribute::TARGET_PROPERTY | \Attribute::IS_REPEATABLE)]
class OrWhere extends Where {
    public function __construct(
        public string|\Stringable|array $field,
        public mixed $value = null,
        public string $operator = Query\Where::OPERATOR_EQUAL,
        public string $condition = Query\Where::CONDITION_OR,
        public string|\Stringable|array|null $fieldValue = null,
        public null|array|\Closure $generateValue = null,
    ) {
        parent::__construct($field, $value, $operator, $condition, $fieldValue, $generateValue);
    }
}