<?php

namespace Ulmus\Entity;

use Ulmus\Common\{ EntityField, EntityResolver };
use Ulmus\{ ConnectionAdapter, EntityCollection, QueryBuilder\QueryBuilderInterface, Repository };

interface EntityInterface /* extends \JsonSerializable */
{
    public function fromArray(iterable $dataset) : static;
    public function entityGetDataset(bool $includeRelations = false, bool $returnSource = false) : array;
    public function toArray($includeRelations = false, array $filterFields = null) : array;
    public function toCollection() : EntityCollection;
    public function isLoaded() : bool;
    public function jsonSerialize() : mixed;
    public static function resolveEntity() : EntityResolver;
    public static function repository(string $alias = Repository::DEFAULT_ALIAS, ConnectionAdapter $adapter = null) : Repository;
    public static function entityCollection(...$arguments) : EntityCollection;
    public static function queryBuilder() : QueryBuilderInterface;
    public static function field($name, null|string|false $alias = Repository::DEFAULT_ALIAS) : EntityField;
    public static function fields(array $fields, null|string|false $alias = Repository::DEFAULT_ALIAS, string $separator = ', ') : string;
}