<?php

namespace Ulmus\Entity\Sqlite;

use Ulmus\ConnectionAdapter;
use Ulmus\EntityCollection;
use Ulmus\Repository;

#[\Ulmus\Attribute\Obj\Table(name: "sqlite_master")]
class Table extends Schema
{
    public static function repository(string $alias = Repository::DEFAULT_ALIAS, ConnectionAdapter $adapter = null): Repository
    {
        $repository = new class(static::class, $alias, $adapter) extends Repository\SqliteRepository
        {
            public function finalizeQuery(): void
            {
                $this->select(Table::field('tableName'))->groupBy(Table::field('tableName'));
            }
        };

         $repository->entityClass = static::class;

         return $repository;
    }
}