<?php

namespace Ulmus\Query;

use Ulmus\QueryBuilder\QueryBuilderInterface;

class Set extends Fragment {

    public int $order = 0;
    
    public array $dataset;

    public ? array $escapedFields;

    public QueryBuilderInterface $queryBuilder;

    public function __construct(QueryBuilderInterface $queryBuilder)
    {
        $this->queryBuilder = $queryBuilder;
    }
    
    public function set(array $dataset, ? array $escapedFields = null) : self
    {
        $this->dataset = $dataset;
        $this->escapedFields = $escapedFields;

        return $this;
    }

    public function render() : mixed
    {                    
        return $this->renderSegments([
            'SET', $this->renderParameterPlaceholders(),
        ]);
    }
    
    public function renderParameterPlaceholders() : string 
    {        
        $keys = [];

        foreach($this->dataset as $key =>$value) {
            $this->queryBuilder->addParameter($value, ":v_$key");

            $field = $this->escapedFields[$key] ?? $key;

            $keys[] = "{$field}=:v_{$key}";
        }
        
        return implode(",", $keys);
    }
}